package net.controller;

import java.util.ArrayList;
import java.util.List;

import hibernate.HibernateUtil;

import net.models.Etat;
import net.models.Familles;
import net.models.Fichefrais;
import net.models.Fraisforfait;
import net.models.Groups;
import net.models.Labos;
import net.models.Medicaments;
import net.models.Motifs;
import net.models.Praticiens;
import net.models.RapportsVisites;
import net.models.TypesPraticiens;
import net.models.Users;

import org.hibernate.Query;
import org.hibernate.Session;

public class AppController {

	private static String securitySalt = "IxafG9ffQIxN4VbtGpRiD6sXI0ESNFcdhCgRBJvR";
	private static List<Medicaments> listMedicaments = new ArrayList<>();
	private static List<Familles> listFamilles = new ArrayList<>();
	private static List<Fichefrais> listFicheFrais = new ArrayList<>();
	private static List<Praticiens> listPraticiens = new ArrayList<>();
	private static List<Fraisforfait> listFraisForfait = new ArrayList<>();
	private static List<Etat> listEtats = new ArrayList<>();
	private static List<Users> listUsers = new ArrayList<>();
	private static List<TypesPraticiens> listTypesPraticiens = new ArrayList<>();
	private static List<Groups> listGroups = new ArrayList<>();
	private static List<Motifs> listMotifs = new ArrayList<>();
	private static List<RapportsVisites> listRapportsVisites = new ArrayList<>();
	private static List<Labos> listLabos = new ArrayList<>();
	private static Users activeUser = new Users();
	
	public static Users getActiveUser(){
		return activeUser;
	}
	
	public static void setActiveUser(Users user){
		activeUser = user;
	}
	
	public static String getSecuritySalt(){
		return securitySalt;
	}
	
	/*
	 * Mdicaments
	 */
	public static List<Medicaments> getListMedicaments(){
		return listMedicaments;
	}
	
	public static void initListMedicaments(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Medicaments");
		listMedicaments  = query.list();
		session.close();
	}
	
	/*
	 * Familles
	 */
	public static List<Familles> getListFamilles(){
		return listFamilles;
	}
	
	public static void initListFamilles(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Familles");
		listFamilles  = query.list();
		session.close();
	}
	
	/*
	 * Fiche de frais
	 */
	public static List<Fichefrais> getListFicheFrais(){
		return listFicheFrais;
	}
	
	public static void initListFicheFrais(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Fichefrais");
		listFicheFrais  = query.list();
		session.close();
	}
	
	/*
	 * Praticiens
	 */
	public static List<Praticiens> getListPraticiens(){
		return listPraticiens;
	}
	
	public static void initListPraticiens(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Praticiens");
		listPraticiens = query.list();
		session.close();
	}
	
	/*
	 * Frais Forfaitaire
	 */
	public static List<Fraisforfait> getListFraisForfait(){
		return listFraisForfait;
	}
	
	public static void initListFraisForfait(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Fraisforfait");
		listFraisForfait = query.list();
		session.close();
	}
	
	/*
	 * Etat
	 */
	public static List<Etat> getListEtats(){
		return listEtats;
	}
	
	public static void initListEtats(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Etat");
		listEtats = query.list();
		session.close();
	}
	
	/*
	 * Users
	 */
	public static List<Users> getListUsers(){
		return listUsers;
	}
	
	public static void initListUsers(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Users");
		listUsers = query.list();
		session.close();
	}
	
	/*
	 * Types Praticiens
	 */
	public static List<TypesPraticiens> getListTypesPraticiens(){
		return listTypesPraticiens;
	}
	
	public static void initListTypesPraticiens(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from TypesPraticiens");
		listTypesPraticiens = query.list();
		session.close();
	}
	
	/*
	 * Groupes d'utilisateurs
	 */
	public static List<Groups> getListGroups(){
		return listGroups;
	}
	
	public static void initListGroups(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Groups");
		listGroups = query.list();
		session.close();
	}
	
	/*
	 * Motifs visite
	 */
	public static List<Motifs> getListMotifs(){
		return listMotifs;
	}
	
	public static void initListMotifs(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Motifs");
		listMotifs = query.list();
		session.close();
	}
	
	/*
	 * Rapports Visites
	 */
	public static List<RapportsVisites> getListRapportsVisites(){
		return listRapportsVisites;
	}
	
	public static void initListRapportsVisites(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from RapportsVisites");
		listRapportsVisites = query.list();
		session.close();
	}
	
	/*
	 * Laboratoire
	 */
	public static List<Labos> getListLabos(){
		return listLabos;
	}
	
	public static void initListLabos(){
		Session session = HibernateUtil.getSession();
		Query query = session.createQuery("from Labos");
		listLabos = query.list();
		session.close();
	}
}