package net.view;

import hibernate.HibernateUtil;

import java.util.List;

import net.controller.AppController;
import net.models.Etat;
import net.models.Fichefrais;
import net.models.Lignefraisforfait;
import net.models.LignefraisforfaitId;
import net.models.Lignefraishorsforfait;
import net.models.Users;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.ui.handlers.CollapseAllHandler;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TableViewerColumn;
import org.eclipse.core.databinding.DataBindingContext;
import org.eclipse.jface.databinding.viewers.ObservableListContentProvider;
import org.eclipse.core.databinding.observable.map.IObservableMap;
import org.eclipse.core.databinding.beans.BeansObservables;
import org.eclipse.jface.databinding.viewers.ObservableMapLabelProvider;
import org.eclipse.core.databinding.observable.list.IObservableList;
import org.eclipse.core.databinding.property.Properties;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

public class FicheFrais_index extends Composite {
	private DataBindingContext m_bindingContext;
	private Table table;
	private List<Fichefrais> listFicheFrais;
	private List<Etat> listEtats;
	private List<Users> listUsers;
	private TableViewer tableViewer;
	private ComboViewer comboViewer_4;
	private ComboViewer comboViewer_3;
	public static IObservableList selfList;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public FicheFrais_index(Composite parent, int style) {
		super(parent, style);
		setLayout(new FormLayout());
		
		listFicheFrais = AppController.getListFicheFrais();
		listEtats = AppController.getListEtats();
		listUsers = AppController.getListUsers();
		
		Group grpCritres = new Group(this, SWT.NONE);
		FormData fd_grpCritres = new FormData();
		fd_grpCritres.bottom = new FormAttachment(0, 139);
		fd_grpCritres.right = new FormAttachment(0, 267);
		fd_grpCritres.top = new FormAttachment(0, 10);
		fd_grpCritres.left = new FormAttachment(0, 10);
		grpCritres.setLayoutData(fd_grpCritres);
		grpCritres.setText("Crit\u00E8res");
		
		Label lblNewLabel = new Label(grpCritres, SWT.NONE);
		lblNewLabel.setBounds(10, 20, 59, 14);
		lblNewLabel.setText("Etat");
		
		Label lblVisiteur = new Label(grpCritres, SWT.NONE);
		lblVisiteur.setBounds(10, 40, 59, 14);
		lblVisiteur.setText("Visiteur");
		
		Label lblMontantMin = new Label(grpCritres, SWT.NONE);
		lblMontantMin.setBounds(10, 60, 72, 14);
		lblMontantMin.setText("Montant Min");
		
		Label lblMontantMac = new Label(grpCritres, SWT.NONE);
		lblMontantMac.setBounds(10, 80, 79, 14);
		lblMontantMac.setText("Montant Max");
		
		Label lblMois = new Label(grpCritres, SWT.NONE);
		lblMois.setBounds(10, 100, 59, 14);
		lblMois.setText("Mois");
		
		ComboViewer comboViewer = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboMontantMax = comboViewer.getCombo();
		comboMontantMax.setBounds(156, 77, 91, 23);
		
		ComboViewer comboViewer_1 = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboMois = comboViewer_1.getCombo();
		comboMois.setBounds(156, 97, 91, 23);
		
		ComboViewer comboViewer_2 = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboMontantMin = comboViewer_2.getCombo();
		comboMontantMin.setBounds(156, 57, 91, 23);
		
		comboViewer_3 = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboVisiteur = comboViewer_3.getCombo();
		comboVisiteur.setBounds(156, 37, 91, 23);
		
		comboViewer_4 = new ComboViewer(grpCritres, SWT.READ_ONLY);
		Combo comboEtat = comboViewer_4.getCombo();
		comboEtat.setBounds(156, 17, 91, 23);
		
		Group grpFicheDeFrais = new Group(this, SWT.NONE);
		FormData fd_grpFicheDeFrais = new FormData();
		fd_grpFicheDeFrais.top = new FormAttachment(0, 10);
		fd_grpFicheDeFrais.left = new FormAttachment(0, 273);
		grpFicheDeFrais.setLayoutData(fd_grpFicheDeFrais);
		grpFicheDeFrais.setText("Fiche de frais");
		grpFicheDeFrais.setLayout(new FormLayout());
		
		tableViewer = new TableViewer(grpFicheDeFrais, SWT.BORDER | SWT.FULL_SELECTION);
		table = tableViewer.getTable();
		table.setHeaderVisible(true);
		FormData fd_table = new FormData();
		fd_table.bottom = new FormAttachment(0, 164);
		fd_table.top = new FormAttachment(0, 10);
		fd_table.right = new FormAttachment(100, -10);
		fd_table.left = new FormAttachment(0, 7);
		table.setLayoutData(fd_table);
		m_bindingContext = initDataBindings();
		
		TableViewerColumn columnUser = new TableViewerColumn(tableViewer, SWT.NONE);
		TableViewerColumn columnMois = new TableViewerColumn(tableViewer, SWT.NONE);
		
		columnUser.getColumn().setText("Visiteur");
		columnMois.getColumn().setText("Mois");
		
		columnUser.getColumn().setWidth(150);
		columnMois.getColumn().setWidth(123);
		
		Group group = new Group(this, SWT.NONE);
		fd_grpFicheDeFrais.right = new FormAttachment(group, 0, SWT.RIGHT);
		fd_grpFicheDeFrais.bottom = new FormAttachment(group, -5);
		FormData fd_group = new FormData();
		fd_group.bottom = new FormAttachment(100, -10);
		fd_group.top = new FormAttachment(0, 204);
		fd_group.left = new FormAttachment(0, 10);
		fd_group.right = new FormAttachment(100, -10);
		group.setLayoutData(fd_group);
		
		Button btnDelete = new Button(group, SWT.NONE);
		btnDelete.setBounds(569, 21, 81, 25);
		btnDelete.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				IStructuredSelection sel = (IStructuredSelection) tableViewer.getSelection();
				if(sel != null){
					Fichefrais ff = (Fichefrais) sel.getFirstElement();
					Session session = HibernateUtil.getSession();
					Transaction tx = session.beginTransaction();
					
					//On commence par rechercher les lignes associs et les supprimer
					Query query = session.createQuery("from Lignefraisforfait where fichefrais.id="+ff.getId());
					List<Lignefraisforfait> listLFF = query.list();
					for (Lignefraisforfait lignefraisforfait : listLFF) {
						session.delete(lignefraisforfait);
					}
					
					query = session.createQuery("from Lignefraishorsforfait where fichefrais.id="+ff.getId());
					List<Lignefraishorsforfait> listLFHF = query.list();
					for (Lignefraishorsforfait lignefraishorsforfait : listLFHF) {
						session.delete(lignefraishorsforfait);
					}
					
					session.delete(ff);
					tx.commit();
					session.close();
					AppController.initListFicheFrais();
					getListInput().remove(ff);
				}
			}
		});
		btnDelete.setText("Delete");
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	protected DataBindingContext initDataBindings() {
		DataBindingContext bindingContext = new DataBindingContext();
		//
		ObservableListContentProvider listContentProvider = new ObservableListContentProvider();
		IObservableMap[] observeMaps = BeansObservables.observeMaps(listContentProvider.getKnownElements(), Fichefrais.class, new String[]{"users.nom", "mois"});
		tableViewer.setLabelProvider(new ObservableMapLabelProvider(observeMaps));
		tableViewer.setContentProvider(listContentProvider);
		//
		selfList = Properties.selfList(Fichefrais.class).observe(listFicheFrais);
		tableViewer.setInput(selfList);
		//
		ObservableListContentProvider listContentProvider_1 = new ObservableListContentProvider();
		IObservableMap observeMap = BeansObservables.observeMap(listContentProvider_1.getKnownElements(), Etat.class, "libelle");
		comboViewer_4.setLabelProvider(new ObservableMapLabelProvider(observeMap));
		comboViewer_4.setContentProvider(listContentProvider_1);
		//
		IObservableList selfList_1 = Properties.selfList(Etat.class).observe(listEtats);
		comboViewer_4.setInput(selfList_1);
		//
		ObservableListContentProvider listContentProvider_2 = new ObservableListContentProvider();
		IObservableMap[] observeMaps_1 = BeansObservables.observeMaps(listContentProvider_2.getKnownElements(), Users.class, new String[]{"nom", "prenom"});
		comboViewer_3.setLabelProvider(new ObservableMapLabelProvider(observeMaps_1));
		comboViewer_3.setContentProvider(listContentProvider_2);
		//
		IObservableList selfList_2 = Properties.selfList(Users.class).observe(listUsers);
		comboViewer_3.setInput(selfList_2);
		//
		return bindingContext;
	}
	
	public IObservableList getListInput(){
		return selfList;
	}
}
