package net.gui;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;

public class RapportsVisites_show {

	protected Shell shlRapportDeVisite;
	private Text text;
	private Text text_1;
	private Text text_2;
	private Text text_3;
	private Text text_4;
	private Text text_5;
	private Table table;
	private Table table_1;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			RapportsVisites_show window = new RapportsVisites_show();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shlRapportDeVisite.open();
		shlRapportDeVisite.layout();
		while (!shlRapportDeVisite.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shlRapportDeVisite = new Shell(Display.getDefault(), SWT.APPLICATION_MODAL | SWT.CLOSE);
		shlRapportDeVisite.setSize(718, 509);
		shlRapportDeVisite.setText("Rapport de visite");
		
		Group group = new Group(shlRapportDeVisite, SWT.NONE);
		group.setText("Rapport de visite");
		group.setBounds(10, 10, 340, 221);
		
		Label label = new Label(group, SWT.NONE);
		label.setText("Date");
		label.setBounds(10, 27, 59, 14);
		
		Label label_1 = new Label(group, SWT.NONE);
		label_1.setText("Visiteur");
		label_1.setBounds(10, 47, 59, 14);
		
		Label label_2 = new Label(group, SWT.NONE);
		label_2.setText("Praticien");
		label_2.setBounds(10, 67, 59, 14);
		
		Label label_3 = new Label(group, SWT.NONE);
		label_3.setText("Motif");
		label_3.setBounds(10, 107, 59, 14);
		
		Label label_4 = new Label(group, SWT.NONE);
		label_4.setText("Bilan");
		label_4.setBounds(10, 127, 59, 14);
		
		Label label_5 = new Label(group, SWT.NONE);
		label_5.setText("Remplacant");
		label_5.setBounds(10, 87, 67, 14);
		
		text = new Text(group, SWT.BORDER);
		text.setBounds(117, 24, 209, 19);
		
		text_1 = new Text(group, SWT.BORDER);
		text_1.setBounds(117, 44, 209, 19);
		
		text_2 = new Text(group, SWT.BORDER);
		text_2.setBounds(117, 64, 209, 19);
		
		text_3 = new Text(group, SWT.BORDER);
		text_3.setBounds(117, 84, 209, 19);
		
		text_4 = new Text(group, SWT.BORDER);
		text_4.setBounds(117, 104, 209, 19);
		
		text_5 = new Text(group, SWT.BORDER);
		text_5.setBounds(117, 124, 209, 87);
		
		Group group_1 = new Group(shlRapportDeVisite, SWT.NONE);
		group_1.setText("Echantillons");
		group_1.setBounds(10, 237, 340, 183);
		
		table = new Table(group_1, SWT.BORDER | SWT.FULL_SELECTION);
		table.setLinesVisible(true);
		table.setHeaderVisible(true);
		table.setBounds(10, 27, 316, 146);
		
		Group group_2 = new Group(shlRapportDeVisite, SWT.NONE);
		group_2.setText("Pr\u00E9sentations");
		group_2.setBounds(350, 237, 340, 183);
		
		table_1 = new Table(group_2, SWT.BORDER | SWT.FULL_SELECTION);
		table_1.setLinesVisible(true);
		table_1.setHeaderVisible(true);
		table_1.setBounds(10, 27, 316, 146);
		
		Group group_3 = new Group(shlRapportDeVisite, SWT.NONE);
		group_3.setBounds(10, 426, 680, 43);
		
		Button button = new Button(group_3, SWT.NONE);
		button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
				shlRapportDeVisite.close();
			}
		});
		button.setText("Fermer");
		button.setBounds(291, 10, 94, 28);

	}

}
