package net.view;

import net.gui.MainWindow;

import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Canvas;

public class Accueil_index extends Composite {

	private final FormToolkit toolkit = new FormToolkit(Display.getCurrent());

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public Accueil_index(Composite parent, int style) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				toolkit.dispose();
			}
		});
		toolkit.adapt(this);
		toolkit.paintBordersFor(this);
		setLayout(null);
		
		Label lblLeLaboratoireGalaxy = new Label(this, SWT.NONE);
		lblLeLaboratoireGalaxy.setBounds(10, 10, 380, 25);
		lblLeLaboratoireGalaxy.setFont(SWTResourceManager.getFont("Segoe UI", 14, SWT.BOLD));
		toolkit.adapt(lblLeLaboratoireGalaxy, true, true);
		lblLeLaboratoireGalaxy.setText("Le Laboratoire Galaxy Swiss Bourdin (GSB)");
		
		Label lblLeLaboratoireGalaxy_1 = new Label(this, SWT.NONE);
		lblLeLaboratoireGalaxy_1.setBounds(160, 70, 512, 92);
		toolkit.adapt(lblLeLaboratoireGalaxy_1, true, true);
		lblLeLaboratoireGalaxy_1.setText("Le laboratoire Galaxy Swiss Bourdin (GSB) est issu de la fusion entre le g\u00E9ant am\u00E9ricain \r\nGalaxy (sp\u00E9cialis\u00E9 dans le secteur des maladies virales dont le SIDA et les h\u00E9patites) \r\net le conglom\u00E9rat europ\u00E9en Swiss Bourdin (travaillant sur des m\u00E9dicaments plus conventionnels),\r\nlui m\u00EAme d\u00E9j\u00E0 union de trois petits laboratoires .");
		
		Group group = new Group(this, SWT.NONE);
		group.setBounds(10, 57, 144, 98);
		group.setBackgroundImage(SWTResourceManager.getImage(Accueil_index.class, "/img/gsb.jpg"));
		toolkit.adapt(group);
		toolkit.paintBordersFor(group);

	}
}
